Unit AEE5R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AMA1R_p;

function AEE5R(var A :Array of Real; var B :Array of Real;
                N :Integer; K :Integer): Real;

implementation

function AEE5R(var A :Array of Real; var B :Array of Real;
                N :Integer; K :Integer): Real;
var
J,L,P1 :Integer;
D,E,F,G,S,T,V,X,WMIN2,HM :Real;
const
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7;
begin
{ Result -    AEE5R  FORTRANe }
WMIN2 := SYS051;
Result := A[0];
if ( N = 1 ) 
 then goto _7;
AMA1R(A,B,N,D,E,HM,P1);
G := EMax1(Abs(E),Abs(D))*WMIN2;
S := 2.0*WMIN2;
_1:
F := (D+E)*0.5;
if ( E-D <= (Abs(E)+Abs(D))*S+G ) 
 then goto _6;
L := 0;
V := A[0]-F;
if ( V < 0.0 ) 
 then L := 1;
for J:=2 to N do
 begin
  T := B[J-1];
  if ( V <> 0.0 ) 
   then goto _2;
  X := Abs(T)/WMIN2;
  goto _3;
_2:
  X := (T/V)*T;
_3:
  V := A[J-1]-F-X;
  if ( V < 0.0 ) 
   then L := L+1;
_4:
 end;
if ( L >= K ) 
 then goto _5;
D := F;
goto _1;
_5:
E := F;
goto _1;
_6:
Result := F;
if ( P1 = 0 ) 
 then goto _7;
Result := F/HM;
_7:
exit;
end;

end.
